#include "testlib.h"

using namespace std;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n = argc > 2 ? opt<int>(2) : rnd.next(1, 500);
    int m = argc > 3 ? opt<int>(3) : rnd.next(1, 500);
    cout << n << " " << m << "\n";

    set<int> used;

    vector<vector<int>> U (n);

    for (int i = 0; i < n; i++) {
        int lui = argc > 4 ? opt<int>(4) : rnd.next(1, m);
        U[i] = rnd.distinct(lui, 1, m);
        for (int uij : U[i]) { used.insert(uij); }
    }

    for (int u = 1; u <= m; u++) if (!used.count(u)) {
        int where;
        do {
            where = rnd.next(0, n-1);
        } while (U[where].size() == m);
        U[where].push_back(u);
    }

    for (int i = 0; i < n; i++) {
        cout << U[i].size();
        if (argc > 5 && opt<int>(5) == -1) {
            sort(U[i].rbegin(), U[i].rend());
        }
        if (argc > 5 && opt<int>(5) == +1) {
            sort(U[i].begin(), U[i].end());
        }

        for (int uij : U[i]) {
            cout << " " << uij;
        }
        cout << "\n";
    }
}
