#include "testlib.h"

using namespace std;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int N = inf.readInt(1, 500, "N");
    inf.readSpace();
    int M = inf.readInt(1, 500, "M");
    inf.readEoln();

    set<int> used;

    for (int i = 0; i < N; i++) {
        int lui = inf.readInt(1, M, "|Ui|");
        for (int j = 0; j < lui; j++) {
            inf.readSpace();
            int uij = inf.readInt(1, M, "uij");
            used.insert(uij);
        }
        inf.readEoln();
    }

    if (used.size() != M) {
        quitf(_wa, "expected all %d numbers to be used", M);
    }

    inf.readEof();
}
