#include <bits/stdc++.h>
using namespace std;

int N = 1000+15;

const int oo = 987654321;

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    vector<int> Us (n);
    vector<vector<int>> U (n, vector<int>(m));
    for (int u = 0; u < n; u++) {
        cin >> Us[u];

        for (int j = 0; j < Us[u]; j++) {
            int v;
            cin >> v;
            v--;

            U[u][v] = 1;
        }
    }

    vector<vector<int>> cnt (n, vector<int>(n, 0));

    for (int j = 0; j < m; j++) {
        for (int u = 0; u < n; u++) if (U[u][j]) {
            for (int v = 0; v < n; v++) if (U[v][j]) {
                cnt[u][v]++;
            }
        }
    }

    for (int u = 0; u < n; u++) {
        bool has_subset = false;

        for (int v = 0; !has_subset && v < n; v++) if (u != v) {
            has_subset = cnt[u][v] == Us[v] && cnt[u][v] == Us[u] ? u > v : cnt[u][v] == Us[v];
        }

        if (!has_subset) {
            cout << u << "\n";
        }
    }
}
