import java.util.Scanner;
import java.util.Arrays;

public class DadosVazados {
  public static void main(String[] args) {
    Scanner sc = new Scanner(System.in);

    int n = sc.nextInt();
    int m = sc.nextInt();

    int[][] U = new int[n][m];
    for (int u = 0; u < n; u++) {
      int j = sc.nextInt();
      for (int jj = 0; jj < j; jj++) {
        int v = sc.nextInt();
        v--;
        U[u][v] = 1;
      }
    }

    for (int u = 0; u < n; u++) {
      boolean has_subset = false;

      for (int v = 0; !has_subset && v < n; v++) if (u != v) {
        has_subset = true;
        for (int j = 0; j < m; j++) if (U[v][j] == 1 && U[u][j] == 0) {
          has_subset = false;
          break;
        }
        if (has_subset && Arrays.equals(U[u], U[v])) { has_subset = u > v; }
      }

      if (!has_subset) {
        System.out.println(u);
      }
    }
  }
}
