#include <bits/stdc++.h>
using namespace std;

int N = 1000+15;

const int oo = 987654321;

template <typename T>
bool is_subset(std::set<T> A, std::set<T> B) {
    return std::includes(A.begin(), A.end(), B.begin(), B.end());
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    vector<set<int>> U (n);
    for (int u = 0; u < n; u++) {
        int m;
        cin >> m;

        for (int j = 0; j < m; j++) {
            int v;
            cin >> v;
            v--;

            U[u].insert(v);
        }
    }

    for (int u = 0; u < n; u++) {
        bool has_subset = false;

        for (int v = 0; !has_subset && v < n; v++) if (u != v) {
            bool subset = is_subset(U[u], U[v]);
            has_subset = subset && U[u] == U[v] ? u > v : subset;
        }

        if (!has_subset) {
            cout << u << "\n";
        }
    }
}
