import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.util.Arrays;

public class DadosVazados {
  public static void main(String[] args) throws IOException {
    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    StringTokenizer st = new StringTokenizer(br.readLine());

    int n = Integer.parseInt(st.nextToken());
    int m = Integer.parseInt(st.nextToken());

    int[][] U = new int[n][m];
    for (int u = 0; u < n; u++) {
      st = new StringTokenizer(br.readLine());
      int j = Integer.parseInt(st.nextToken());
      for (int jj = 0; jj < j; jj++) {
        int v = Integer.parseInt(st.nextToken());
        v--;
        U[u][v] = 1;
      }
    }

    for (int u = 0; u < n; u++) {
      boolean has_subset = false;

      for (int v = 0; !has_subset && v < n; v++) if (u != v) {
        has_subset = true;
        for (int j = 0; j < m; j++) if (U[v][j] == 1 && U[u][j] == 0) {
          has_subset = false;
          break;
        }
        if (has_subset && Arrays.equals(U[u], U[v])) { has_subset = u > v; }
      }

      if (!has_subset) {
        System.out.println(u);
      }
    }
  }
}
